//______________________________________________________________________________
// DissolveModelPlugin
// 2010/06/20 by Eugen Sares
//
// Usage: select a Model,
// Model > Modify > Model > Dissolve Model.
//______________________________________________________________________________

function XSILoadPlugin( in_reg )
{
	in_reg.Author = "Eugen Sares";
	in_reg.Name = "DissolveModelPlugin";
	in_reg.Major = 1;
	in_reg.Minor = 0;

	in_reg.RegisterCommand("DissolveModel","DissolveModel");
	in_reg.RegisterMenu(siMenuTbModelModifyModelID,"DissolveModel_Menu",false,false);
	//RegistrationInsertionPoint - do not remove this line

	return true;
}

function XSIUnloadPlugin( in_reg )
{
	var strPluginName;
	strPluginName = in_reg.Name;
	Application.LogMessage(strPluginName + " has been unloaded.",siVerbose);
	return true;
}

function DissolveModel_Init( in_ctxt )
{
	var oCmd;
	oCmd = in_ctxt.Source;
	oCmd.Description = "";
	oCmd.ReturnValue = true;

	return true;
}


//______________________________________________________________________________

function DissolveModel_Execute(  )
{
	Application.LogMessage("DissolveModel_Execute called",siVerbose);

	var cSel = Application.Selection;
	var cModels = SIFilter(cSel, "model");
	if(cModels)
	{
		Selection.Clear();
		for(var i = 0; i < cModels.Count; i++)
		{
			var oModel = cModels(i);
			var cChildren = cModels(i).Children;
			AddToSelection(cChildren);
			oModel.RemoveChild(cChildren);
			DeleteObj(oModel);
		}
	}

	return true;
}


//______________________________________________________________________________

function DissolveModel_Menu_Init( in_ctxt )
{
	var oMenu;
	oMenu = in_ctxt.Source;
	oMenu.AddCommandItem("Dissolve Model","DissolveModel");
	return true;
}

